package schedframe.events.scheduling;

import java.util.List;

import schedframe.events.EventReason;


public class TaskCanceledEvent extends SchedulingEvent {

	protected String jobId;
	protected String taskId;
	protected List<String> epr;
	
	public TaskCanceledEvent(List<String> list){
		super(SchedulingEventType.TASK_CANCELED);
		this.epr = list;
		this.jobId = null;
		this.taskId = null;
	}
	
	public TaskCanceledEvent(String jobId, String taskId) {
		super(SchedulingEventType.TASK_CANCELED);
		this.jobId = jobId;
		this.taskId = taskId;
	}
	
	public void setReason(EventReason reason){
		this.reason = reason;
	}

	public String getJobId() {
		return jobId;
	}

	public String getTaskId() {
		return taskId;
	}
	
	public List<String> getReservations(){
		return this.epr;
	}

}
