package schedframe.resources.devices;

import java.util.ArrayList;
import java.util.List;

import schedframe.resources.computing.ComputingResource;
import schedframe.resources.devices.description.DeviceDescription;

public class Fan extends Device{

	protected List<String> chilledResources;
	
	public Fan(DeviceDescription devDesc) {
		super(devDesc);
	}
	
	public List<String> getChilledResources(){
		if(chilledResources == null){
			List<String> resNames =  new ArrayList<String>();
			for(ComputingResource compRes: this.getComputingResource().getChildren()){
				resNames.add(compRes.getFullName());
			}
			return resNames;
		}
		return chilledResources;
	}

	public void setChilledResources(List<String> chilledResources) {
		this.chilledResources = chilledResources;
	}
}
